class Patient:
    """
    Beschreibung der Klasse Patient
    """
    def __init__(self, name):
        self.name = name

    def InformationAusgeben(self):
        print(self.name)

    def NameGeben(self):
        return self.name

class Knoten:
    """
    Beschreibung der Klasse Knoten
    """
    def __init__(self, dneu):
        self.nachfolger = None
        self.daten = dneu

    def NachfolgerSetzen(self, nf):
        self.nachfolger = nf

    def NachfolgerGeben(self):
        return self.nachfolger

    def DatenelementGeben(self):
        return self.daten

    def InformationAusgeben(self):
        self.daten.InformationAusgeben()

class Warteschlange:
    """
    Beschreibung der Warteschlange
    """
    def __init__(self):
        self.anfang = None
        self.ende = None

    def Einfügen(self, patientNeu):
        k = Knoten(patientNeu)
        if self.anfang is None:
            self.anfang = k
        else:
            self.ende.NachfolgerSetzen(k)
        self.ende = k

    def Entfernen(self):
        if self.anfang is not None:
            k = self.anfang
            if self.anfang == self.ende:
                self.anfang = None
                self.ende = None
            else:
                self.anfang = self.anfang.NachfolgerGeben()
            return k.DatenelementGeben()
        else:
            return None

    def InformationAusgeben(self):
        if self.anfang is not None:
            self.anfang.InformationAusgeben()

    def AnfangGeben(self):
        return self.anfang



wartesch1 = Warteschlange()
patient1 = Patient("Andi")
patient2 = Patient("Berin")
patient3 = Patient("Carla")
patient4 = Patient("Didi")
patient5 = Patient("Emil")
patient6 = Patient("Franzi")
patient7 = Patient("Gabi")
patient8 = Patient("Hugo")
patient9 = Patient("Ida")
wartesch1.Einfügen(patient1)
wartesch1.Einfügen(patient2)
wartesch1.Einfügen(patient3)
wartesch1.Einfügen(patient4)
wartesch1.Einfügen(patient5)
wartesch1.Einfügen(patient6)
wartesch1.Einfügen(patient7)
wartesch1.Einfügen(patient8)
wartesch1.Einfügen(patient9)
element = wartesch1.AnfangGeben()
while not element is None:
    element.InformationAusgeben()
    element = element.NachfolgerGeben()
